<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
  <meta http-equiv="content-type"
 content="text/html; charset=ISO-8859-1">
  <title>Compitino</title>
</head>
<body>
<span style="font-weight: bold;">Testi e soluzioni compitino novembre
2003<br>
</span>
<hr style="width: 100%; height: 2px;"><span style="font-weight: bold;"><br>
</span>
<ul>
  <li>Tipo A</li>
  <ul>
    <li><a href="#D1A">Domande</a></li>
    <li><a href="#Es1A">Es 1</a> (coperazione processi)</li>
    <li><a href="#Es2A">Es 2</a> Scheduling</li>
  </ul>
  <li>Tipo B</li>
  <ul>
    <li><a href="#D1B">Domande</a></li>
    <li><a href="#Es1B">Es 1</a> (coperazione processi)</li>
    <li><a href="#Es2B">Es 2</a> Scheduling</li>
  </ul>
</ul>
<span style="font-weight: bold;"><br>
</span>
<hr style="width: 100%; height: 2px;"><span style="font-weight: bold;"><a
 name="D1A"></a>Domande (A)</span><br style="font-weight: bold;">
<br>
<span style="font-weight: bold;">D1)</span> Descrivere il funzionamento
della funzione di sistema <span style="font-weight: bold;">fork</span>
di Unix<br>
<br>
<span style="font-style: italic;">Risposta<br>
Vedi lucidi: creazione di processi,
relazione padre-figlio, gestione spazio di
indirizzamento e risorse, copy-on-write, ecc.</span><br>
<br>
<span style="font-weight: bold;">D2) </span>Descrivere l'<span
 style="font-weight: bold;">algoritmo di Peterson</span>
(in pseudo codice).<br>
<br>
<span style="font-style: italic;">Risposta<br>
</span><span style="font-style: italic;">Vedi lucidi<br>
<br>
</span>
<hr style="width: 100%; height: 2px;"><span style="font-style: italic;"><br>
</span><span style="font-weight: bold;"><a name="D1B"></a>Domande (B)</span><br
 style="font-weight: bold;">
<br>
<span style="font-weight: bold;">D1) </span>Descrivere il meccanismo
dual mode (<span style="font-weight: bold;">User/Kernel</span>) e la
gestione
dei <span style="font-weight: bold;">livelli di contesto </span>in<span
 style="font-weight: bold;"> Unix.</span><br>
<br>
<br>
<span style="font-style: italic;">Risposta:</span><br
 style="font-style: italic;">
<span style="font-style: italic;">Vedi ludici: processi user e kernel,
ciclo di vita di un processo, gestione livelli di contesto in caso di
interrupt</span><br>
<br>
<span style="font-weight: bold;">D2)</span>
Descrivere una soluzione al problema dei <span
 style="font-weight: bold;">lettori-scrittori</span> tramite
<span style="font-weight: bold;">semafori.</span><br
 style="font-weight: bold;">
<br>
<span style="font-style: italic;">Risposta:</span><br
 style="font-style: italic;">
<span style="font-style: italic;">vedi lucidi</span><br>
<hr style="width: 100%; height: 2px;"><br>
<span style="font-weight: bold;"><a name="Es1A"></a>Esercizio 1 (A)<br>
<br>
</span>Considerate i seguenti due processi <br>
<p class="MsoNormal"><!--[endif]--></p>
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 700px;">
  <tbody>
    <tr>
      <td style="vertical-align: top; text-align: left;" rowspan="1"
 colspan="2"><span style="font-weight: bold;">Risorse condivise</span><br>
&nbsp; <span style="font-weight: bold;">semaphore</span>&nbsp; S=1;<o:p></o:p><br>
&nbsp; <span style="font-weight: bold;">semaphore</span>&nbsp; T=0;<o:p></o:p>
      <br>
&nbsp; <span style="font-weight: bold;">int</span> x=0;<br>
&nbsp; <span style="font-weight: bold;">int</span> y=<span
 style="font-weight: bold;">K</span>;<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><span style="font-weight: bold;">Processo</span>
P1<br>
{<br>
&nbsp;<span style="font-weight: bold;">while</span> (y&gt;0) do<br>
&nbsp; {<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">down</span>(&amp;S);&nbsp;
      <br>
&nbsp;&nbsp;&nbsp; x:=x+1;<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">write</span>(x);<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">if</span> (x=y) <span
 style="font-weight: bold;">then</span> <span
 style="font-weight: bold;">up</span>(&amp;T) <br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">else</span> <span
 style="font-weight: bold;">up</span>(&amp;S); <br>
&nbsp; }<br>
      <p class="MsoHeader" style="text-indent: 35.4pt;"><o:p></o:p></p>
      <p class="MsoHeader" style="">}</p>
      </td>
      <td style="vertical-align: top; width: 50%;"><span
 style="font-weight: bold;">Processo</span> P2<br>
{<br>
      <span style="font-weight: bold;">while</span> (true)<br>
&nbsp; {<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">down</span>(&amp;T);&nbsp;
      <br>
&nbsp;&nbsp;&nbsp; y:=x-1;<br>
&nbsp;&nbsp;&nbsp; x:=0;<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">up</span>(&amp;S);&nbsp;&nbsp;&nbsp;
      <br>
&nbsp; }<br>
}<br>
      </td>
    </tr>
  </tbody>
</table>
<br>
supponete che P1 e P2 vengano eseguiti concorrentemente dalla stessa
CPU.
<p class="MsoHeader" style=""><o:p></o:p></p>
<!--[if !supportEmptyParas]--><span style="font-weight: bold;">E1.1)</span>
<br>
Vale la proprieta' di mutua esclusione rispetto alla variabili <span
 style="font-weight: bold;">x</span>? E rispetto a <span
 style="font-weight: bold;">y?<br>
<br>
<br>
<span style="font-style: italic;">Soluzione:<br>
<br>
</span></span>Le <span style="font-weight: bold;">regioni critiche</span>
per P1 sono<br>
<ul>
  <li>condizione (y&gt;0) nel while&nbsp; (y e' condivisa)<br>
  </li>
  <li>codice tra down(&amp;S) e up(&amp;S)/up(&amp;T)<br>
  </li>
</ul>
per P2<br>
<ul>
  <li>codice tra down(&amp;T) e up(&amp;T)<br>
  </li>
</ul>
La prop. di mutua esclusione<span style="font-weight: bold;"> vale </span>per
la variabile <span style="font-weight: bold;">x</span> ma <span
 style="font-weight: bold;">non</span> <span style="font-weight: bold;">vale</span>
per la variabile <span style="font-weight: bold;">y</span>.<br>
<br>
La parte di codice racchiusa tra <span style="font-weight: bold;">down</span>
e <span style="font-weight: bold;">up</span> in P1 e P2 protegge
infatti ogni accesso<br>
(lettura e scrittura) alla variabile x. Per definizione di P1 e P2 solo
uno dei<br>
processi puo accedere alla regione critica per x (P1 e P2 si alternano).<br>
<br>
La variabile <span style="font-weight: bold;">y</span> invece e'
parzialmente protetta dai semafori: la condizione (y&gt;0) <br>
e' potenzialmente&nbsp; soggetta a <span style="font-style: italic;">race-conditions</span>
(cioe' dopo aver passato il test in P1, <br>
la variabile potrebbe assumere un valore =0 a causa dell'intervento di
P2).<span style="font-weight: bold;"><br>
</span><span style="font-weight: bold;"><br>
&nbsp;</span><br>
<span style="font-weight: bold;">E1.2</span>) <br>
Descrivere le possibili sequenze di output per <span
 style="font-weight: bold;">K&gt;1</span> motivando brevemente la
risposta.<br>
<span style="font-weight: bold;"><br>
<span style="font-style: italic;">Soluzione:<br>
</span></span><br>
Quando eseguito su <span style="font-weight: bold;">K</span> fissato e
&gt; 1 il programma concorrente P1 | P2 da origine a <br>
<span style="font-weight: bold;">due</span> possibili sequenze di
output:<br>
<br>
S1=&nbsp; 1 2 ... K&nbsp;&nbsp; 1 2 ... K-1 .... 1 2&nbsp;&nbsp; 1 <br>
S2=&nbsp; 1 2 ... K&nbsp;&nbsp; 1 2 ... K-1 .... 1 2&nbsp;&nbsp;
1&nbsp;&nbsp; 1 <br>
<br>
P1 infatti sblocca P2 solo quando x raggiunge il valore di y. <br>
al che P2&nbsp; decrementa y azzera x e passa il controllo a x.<br>
<br>
Notate tuttavia che quando x=y=1, P1 ha stampato 1 e ha passato il
controllo <br>
a P2 (cioe' ha eseguito up(T) ma non ha ancora controllato (y&gt;0)) <br>
ci sono due possibili
esecuzioni (causate dalla race-condition su y):<br>
<br>
a. viene eseguito prima P2 (che mette y a 0) e poi P1 che esce perche
(y&gt;0)=falso <br>
&nbsp;&nbsp; Questa sequenza corrisponde a S1<br>
<br>
oppure<br>
<br>
b. viene eseguito prima P1 che passa il test (y&gt;0), e si blocca su
S. <br>
&nbsp;&nbsp; A questo punto P2 pone y=0 e x=0 e sblocca P1.<br>
&nbsp;&nbsp; P1 stampa ancora 1, esegue up(S) e poi esce dal ciclo
(y&gt;0)=falso, lasciando<br>
&nbsp;&nbsp; P2 in deadlock per sempre. <br>
&nbsp;&nbsp; Questa sequenza corrisponde a S2<br>
<br>
<br>
<span style="font-weight: bold;">E1.3)</span> <br>
Supponete ora di modificare l'inizializzazione dei semafori come
segue:<br>
&nbsp;&nbsp;&nbsp; <br>
&nbsp;&nbsp; &nbsp;&nbsp; <span style="font-weight: bold;">semaphore</span>&nbsp;
S=0;<o:p></o:p><br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<span style="font-weight: bold;">semaphore</span>&nbsp; T=1;<br>
<br>
Descrivere le possibili sequenze di output per <span
 style="font-weight: bold;">K&gt;1</span> motivando brevemente la
risposta.<br>
<br>
<span style="font-weight: bold;"><span style="font-style: italic;">Soluzione:<br>
<br>
</span></span>Nuovamente ci sono due possibili sequenze<br>
<br>
S1'= vuota<br>
S2'= 1<br>
<br>
Infatti P2 pone y=-1, risveglia P1 e poi va in attesa su T.<br>
P1 potrebbe non essere ancora entrato nel ciclo quindi trova
(y&gt;0)=falso<br>
ed esce: sequenza S1'.<br>
<br>
Se invece P1 era gia in attesa su S: stampa 1 e poi trova
(y&gt;0)=falso ed esce: <br>
sequenza S2'.<br>
<br>
<hr style="width: 100%; height: 2px;"><br>
<span style="font-weight: bold;"><a name="Es1B"></a>Esercizio 1 (B)</span><br>
<br>
Considerate i seguenti due processi <br>
<br>
<p class="MsoNormal"><!--[endif]--></p>
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 700px;">
  <tbody>
    <tr>
      <td style="vertical-align: top; text-align: left;" rowspan="1"
 colspan="2"><span style="font-weight: bold;">Risorse condivise</span><br>
&nbsp; <span style="font-weight: bold;">semaphore</span>&nbsp; S=0;<o:p></o:p><br>
&nbsp; <span style="font-weight: bold;">semaphore</span>&nbsp; T=1;<o:p></o:p>
      <br>
&nbsp; <span style="font-weight: bold;">int</span> x=<span
 style="font-weight: bold;">K</span>;<br>
&nbsp; <span style="font-weight: bold;">int</span> y=<span
 style="font-weight: bold;">K</span>;<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><span style="font-weight: bold;">Processo</span>
P1<br>
{<br>
&nbsp;<span style="font-weight: bold;">while</span> (y&gt;0) do<br>
&nbsp; {<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">down</span>(&amp;S);&nbsp;
      <br>
&nbsp;&nbsp;&nbsp; x:=x+1;<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">write</span>(x);<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">if</span> (x=y) <span
 style="font-weight: bold;">then</span> <span
 style="font-weight: bold;">up</span>(&amp;T) <br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">else</span> <span
 style="font-weight: bold;">up</span>(&amp;S); <br>
&nbsp; }<br>
      <p class="MsoHeader" style="text-indent: 35.4pt;"><o:p></o:p></p>
      <p class="MsoHeader" style="">}</p>
      </td>
      <td style="vertical-align: top; width: 50%;"><span
 style="font-weight: bold;">Processo</span> P2<br>
{<br>
      <span style="font-weight: bold;">while</span> (true)<br>
&nbsp; {<br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">down</span>(&amp;T);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      <br>
&nbsp;&nbsp;&nbsp; y:=x-1;&nbsp;&nbsp;&nbsp;&nbsp;
&nbsp;&nbsp;&nbsp;&nbsp; <br>
&nbsp;&nbsp;&nbsp;
x:=0;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      <br>
&nbsp;&nbsp;&nbsp; <span style="font-weight: bold;">up</span>(&amp;S);&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      <br>
&nbsp; }<br>
}<br>
      </td>
    </tr>
  </tbody>
</table>
<br>
supponete che P1 e P2 vengano eseguiti concorrentemente dalla stessa
CPU.
<p class="MsoHeader" style=""><o:p></o:p></p>
<!--[if !supportEmptyParas]--><span style="font-weight: bold;">E1.1</span>)
<br>
Descrivere le possibili sequenze di output per <span
 style="font-weight: bold;">K&gt;1</span> motivando brevemente la
risposta.<br>
<span style="font-weight: bold;"><span style="font-style: italic;"><br>
</span></span><br>
<span style="font-weight: bold;"><span style="font-style: italic;">Soluzione:<br>
</span></span><br>
Quando eseguito su <span style="font-weight: bold;">K</span> fissato e
&gt; 1 il programma concorrente P1 | P2 da origine a <br>
<span style="font-weight: bold;">due</span> possibili sequenze di
output:<br>
<br>
S1=&nbsp; 1 2 ... K-1 &nbsp; 1 2 ... K-2 .... 1 2&nbsp;&nbsp; 1 <br>
S2=&nbsp; 1 2 ... K-1 &nbsp; 1 2 ... K-2 .... 1 2&nbsp;&nbsp;
1&nbsp;&nbsp; 1 <br>
<br>
Infatti P2 inizialmente mette y a K-1 e x a 0 e poi passa il controllo
a P1.<br>
P1 sblocca P2 solo quando x raggiunge il valore di y. <br>
al che P2&nbsp; decrementa y azzera x e passa il controllo a x.<br>
<br>
Notate tuttavia che quando x=y=1, P1 ha stampato 1 e ha passato il
controllo <br>
a P2 (cioe' ha eseguito up(T) ma non ha ancora controllato (y&gt;0)) <br>
ci sono due possibili
esecuzioni (causate dalla race-condition su y):<br>
<br>
a. viene eseguito prima P2 (che mette y a 0) e poi P1 che esce perche
(y&gt;0)=falso <br>
&nbsp;&nbsp; Questa sequenza corrisponde a S1<br>
<br>
oppure<br>
<br>
b. viene eseguito prima P1 che passa il test (y&gt;0), e si blocca su
S. <br>
&nbsp;&nbsp; A questo punto P2 pone y=0 e x=0 e sblocca P1.<br>
&nbsp;&nbsp; P1 stampa ancora 1, esegue up(S) e poi esce dal ciclo
(y&gt;0)=falso, lasciando<br>
&nbsp;&nbsp; P2 in deadlock per sempre. <br>
&nbsp;&nbsp; Questa sequenza corrisponde a S2<br>
<br>
<span style="font-weight: bold;">E1.2)<br>
</span>Supponete che le parti di codice racchiuse tra <span
 style="font-weight: bold;">down</span> e <span
 style="font-weight: bold;">up </span>in<span
 style="font-weight: bold;"> P1 </span>e<span
 style="font-weight: bold;"> P2 </span>rappresentino <span
 style="font-style: italic;">regioni critiche.<br>
</span>Vale la proprieta' di <span style="font-weight: bold;">progesso</span>
per il sistema globale composta da P1 e P2?<span
 style="font-style: italic;"><br style="font-weight: bold;">
</span><span style="font-weight: bold;"><span
 style="font-style: italic;"><br>
Soluzione:<br>
</span></span><br>
La prop. di progesso<span style="font-weight: bold;"> non vale </span>perche'
quando il processo P1 esce dal while e termina le <br>
sue operazioni P2 rimane sospeso sul semaforo T per sempre -&gt;
dedalock.<br>
<br>
<br>
<span style="font-weight: bold;">E1.3</span>)<br>
Supponete ora di modificare l'<span style="font-weight: bold;">inizializzazione</span>
della variabile <span style="font-weight: bold;">x</span> come segue:<br>
&nbsp;&nbsp;&nbsp; <br>
&nbsp;&nbsp; &nbsp;&nbsp; <span style="font-weight: bold;">int </span>x=<span
 style="font-weight: bold;">0;</span><o:p></o:p><br>
<br>
Descrivere le possibili sequenze di output per <span
 style="font-weight: bold;">K&gt;1</span> motivando brevemente la
risposta.<br>
<br>
<span style="font-weight: bold;"><span style="font-style: italic;">Soluzione:<br>
<br>
</span></span>Nuovamente ci sono due possibili sequenze<br>
<br>
S1'= vuota<br>
S2'= 1<br>
<br>
Infatti P2 pone y=-1, risveglia P1 e poi va in attesa su T.<br>
P1 potrebbe non essere ancora entrato nel ciclo quindi trova
(y&gt;0)=falso<br>
ed esce: sequenza S1'.<br>
<br>
Se invece P1 era gia in attesa su S: stampa 1 e poi trova
(y&gt;0)=falso ed esce: <br>
sequenza S2'.<br>
<br>
<hr style="width: 100%; height: 2px;"><br>
<span style="font-weight: bold;"><a name="Es2A"></a>Esercizio 2 (A)</span><br>
<br>
Considerate i seguenti Job:<br>
<br>
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 100%;">
  <tbody>
    <tr>
      <td style="vertical-align: top; font-weight: bold;">Job<br>
      </td>
      <td style="vertical-align: top; font-weight: bold;">Burst time<br>
      </td>
      <td style="vertical-align: top; font-weight: bold;">Tempo di
arrivo<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">Prima
risposta</span><br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">0<br>
      </td>
      <td style="vertical-align: top;">4.5<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;">3.5<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">2.5<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">D</td>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;">0.5<br>
      </td>
    </tr>
  </tbody>
</table>
<br>
<br>
<span style="font-weight: bold;">E2.1</span>&nbsp; <br>
Supponete di utilizzare una politica <span style="font-weight: bold;">Shortest
Job First</span> senza preemption.<br>
<br>
Assumete che lo scheduler venga attivato quando un job entra nella coda
di attesa e&nbsp; quando un job completa l'esecuzione in CPU.<br>
<br>
Descrivere la sequenza di esecuzione dei job in
CPU e calcolare&nbsp; il tempo di completamento e di risposta di ogni
Job.<br>
<br>
<br>
<span style="font-style: italic; font-weight: bold;">Soluzione</span><br>
<br>
Lo scheduler non applica preemption e quindi non interrompe mai i
processi in esecuzione.<br>
<br>
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 100%;">
  <tbody>
    <tr>
      <td style="vertical-align: top;">0-1<br>
      </td>
      <td style="vertical-align: top;">1-2<br>
      </td>
      <td style="vertical-align: top;">2-3<br>
      </td>
      <td style="vertical-align: top;">3-4<br>
      </td>
      <td style="vertical-align: top;">4-5<br>
      </td>
      <td style="vertical-align: top;">5-6<br>
      </td>
      <td style="vertical-align: top;">6-7<br>
      </td>
      <td style="vertical-align: top;">7-8<br>
      </td>
      <td style="vertical-align: top;">8-9<br>
      </td>
      <td style="vertical-align: top;">9-10<br>
      </td>
      <td style="vertical-align: top;">10-11<br>
      </td>
      <td style="vertical-align: top;">11-12<br>
      </td>
      <td style="vertical-align: top;">12-13<br>
      </td>
      <td style="vertical-align: top;">13-14<br>
      </td>
      <td style="vertical-align: top;">14-15<br>
      </td>
      <td style="vertical-align: top;">15-16<br>
      </td>
      <td style="vertical-align: top;">16-17<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">A</td>
      <td style="vertical-align: top;">A</td>
      <td style="vertical-align: top;">A</td>
      <td style="vertical-align: top;">A</td>
      <td style="vertical-align: top;">A</td>
      <td style="vertical-align: top;">A</td>
      <td style="vertical-align: top;">D<br>
      </td>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">B<br>
      </td>
    </tr>
  </tbody>
</table>
<br>
<br>
Tempi di completamento&nbsp;&nbsp; &nbsp;&nbsp; <br>
A:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 7<br>
B: 17-1= 16<br>
C: 12-3=&nbsp; 9<br>
D: 8-5 =&nbsp; 3<br>
<br>
Tempo di risposta<br>
<br>
A:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 4.5<br>
B: 15.5-1= 14.5 <br>
C: 10.5-3=&nbsp; 7.5<br>
D: 7.5-5 =&nbsp; 2.5<br>
<br>
<span style="font-weight: bold;">E2.2</span> <br>
Considerate ora la seguente politica di scheduling.<br>
<br>
Lo scheduler di lungo termine immette job nella coda di attesa
nell'ordine di arrivo<br>
(supponiamo che tale operazione abbia costo zero).<br>
<br>
<span style="font-weight: bold;">Per ogni job</span> <span
 style="font-weight: bold;">J</span> nel sistema lo scheduler di breve
termine mantiene <span style="font-weight: bold;">due contatori CPU_J
e WAIT_J</span> <br>
inizialmente a zero.<br>
<br>
Lo scheduler viene risvegliato dal clock <span
 style="font-weight: bold;">ogni 2
secondi</span> (tempo 2,4,6,...) ed inoltre&nbsp; <span
 style="font-weight: bold;">quando un job
completa </span><span style="font-weight: bold;">la sua esecuzione</span>.<br>
<br>
In entrambi i casi esegue le seguenti operazioni: <br>
<ul>
  <li>per ogni job <span style="font-weight: bold;">J</span>
incrementa il suo contatore <span style="font-weight: bold;">CPU_J</span>
di <span style="font-weight: bold;">1</span> se <span
 style="font-weight: bold;">J</span> e' nello stato <span
 style="font-weight: bold;">running</span> in CPU, incrementa
il contatore <span style="font-weight: bold;">WAIT_J</span> di <span
 style="font-weight: bold;">1</span> se <span
 style="font-weight: bold;">J</span> e' nello stato <span
 style="font-weight: bold;">ready_to_run </span>(e' nella coda di
attesa)<br>
    <br>
  </li>
  <li>dopo aver aggiornato i contatori di ogni processo, seleziona per
l'esecuzione in CPU il processo tale&nbsp; che <span
 style="font-weight: bold;">WAIT_J &gt; CPU_J</span>, applicando il
criterio <span style="font-weight: bold;">First-Come-First-Served</span>
rispetto al <span style="font-weight: bold;">tempo di arrivo</span>
(vedi tabella) nel caso in cui siano possibili diverse scelte o nel
caso in cui WAIT_J =&lt; CPU_J per ogni J.<br>
  </li>
</ul>
Descrivere la sequenza di esecuzione dei job in
CPU&nbsp; e calcolare il <span style="font-weight: bold;">tempo di
completamento</span> e <br>
di <span style="font-weight: bold;">risposta</span> di ogni Job.<br>
<br>
<br>
<br>
<span style="font-style: italic; font-weight: bold;">Soluzione</span><br>
<br>
<table cellpadding="2" cellspacing="2" border="1"
 style="text-align: left; width: 100%;">
  <tbody>
    <tr>
      <td style="vertical-align: top;">0-1<br>
      </td>
      <td style="vertical-align: top;">1-2<br>
      </td>
      <td style="vertical-align: top;">2-3<br>
      </td>
      <td style="vertical-align: top;">3-4<br>
      </td>
      <td style="vertical-align: top;">4-5<br>
      </td>
      <td style="vertical-align: top;">5-6<br>
      </td>
      <td style="vertical-align: top;">6-7<br>
      </td>
      <td style="vertical-align: top;">7-8<br>
      </td>
      <td style="vertical-align: top;">8-9<br>
      </td>
      <td style="vertical-align: top;">9-10<br>
      </td>
      <td style="vertical-align: top;">10-11<br>
      </td>
      <td style="vertical-align: top;">11-12<br>
      </td>
      <td style="vertical-align: top;">12-13<br>
      </td>
      <td style="vertical-align: top;">13-14<br>
      </td>
      <td style="vertical-align: top;">14-15<br>
      </td>
      <td style="vertical-align: top;">15-16<br>
      </td>
      <td style="vertical-align: top;">16-17<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">A <br>
      </td>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">D<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wa=0 (*)<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wa=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wa=2</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wa=2</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wa=3</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wa=3</td>
      <td style="vertical-align: top;">Wa=4</td>
      <td style="vertical-align: top;">&nbsp;/<br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Ca=1<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Ca=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Ca=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Ca=2</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Ca=2</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Ca=3</td>
      <td style="vertical-align: top;">Ca=3</td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wb=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wb=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wb=2</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wb=3</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wb=3</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wb=4</td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cb=0</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cb=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cb=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cb=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cb=2</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cb=2</td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wc=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wc=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wc=2</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wc=3</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wc=4<br>
      </td>
      <td style="vertical-align: top;">Wc=5</td>
      <td style="vertical-align: top;">Wc=6<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cc=0</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cc=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cc=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cc=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cc=1</td>
      <td style="vertical-align: top;">Cc=1</td>
      <td style="vertical-align: top;">Cc=1<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wd=1<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wd=2</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wd=3</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wd=4</td>
      <td style="vertical-align: top;">Wd=5<br>
      </td>
      <td style="vertical-align: top;">Wd=6</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wd=7</td>
      <td style="vertical-align: top;">/<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cd=0</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cd=0</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cd=0</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cd=0</td>
      <td style="vertical-align: top;">Cd=0</td>
      <td style="vertical-align: top;">Cd=0 <br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cd=0</td>
      <td style="vertical-align: top;">/<br>
      </td>
    </tr>
  </tbody>
</table>
<br>
Al tempo 0 i contatori sono tutti a 0, A entra e lo scheduler viene
attivato al tempo 2.<br>
<br>
(*) nella colonna [i,i+1] indica aggiornamento delle variabili al
tempo i+1 <br>
<br>
<br>
Tempi di completamento&nbsp;&nbsp; &nbsp;&nbsp; <br>
A: 14<br>
B: 13-1=12 <br>
C: 16-3=13<br>
D: 17-5=12<br>
<br>
Tempo di risposta<br>
<br>
A: 10.5 <br>
B:&nbsp; 9.5 <br>
C: 14.5 <br>
D: 16.5<br>
<br>
<hr style="width: 100%; height: 2px;"><br>
<span style="font-weight: bold;"><a name="Es2B"></a>Esercizio 2 (B)</span><br>
<br>
Considerate i seguenti Job:<br>
<br>
<table cellpadding="2" cellspacing="2" border="1"
 style="text-align: left; width: 100%;">
  <tbody>
    <tr>
      <td style="vertical-align: top; font-weight: bold;">Job<br>
      </td>
      <td style="vertical-align: top; font-weight: bold;">Burst time<br>
      </td>
      <td style="vertical-align: top; font-weight: bold;">Tempo di
arrivo<br>
      </td>
      <td style="vertical-align: top;"><span style="font-weight: bold;">Prima
risposta</span><br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">7<br>
      </td>
      <td style="vertical-align: top;">0<br>
      </td>
      <td style="vertical-align: top;">4.5<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;">3.5<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">4<br>
      </td>
      <td style="vertical-align: top;">3<br>
      </td>
      <td style="vertical-align: top;">2.5<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">D</td>
      <td style="vertical-align: top;">1<br>
      </td>
      <td style="vertical-align: top;">5<br>
      </td>
      <td style="vertical-align: top;">0.5<br>
      </td>
    </tr>
  </tbody>
</table>
<br>
<br>
<span style="font-weight: bold;">E2.1</span> <br>
Supponete di utilizzare una politica <span style="font-weight: bold;">Shortest
Job First</span> con preemption <br>
(chiamata anche <span style="font-weight: bold;">Shortest
Remaining-Time First</span>).<br>
Assumete che lo scheduler venga attivato quando un job entra nella coda
di attesa e <br>
quando un job completa l'esecuzione in CPU.<br>
<br>
Descrivere la sequenza di esecuzione dei job in
CPU e calcolare <br>
il tempo di completamento e di risposta di ogni Job.<br>
<br>
<span style="font-style: italic; font-weight: bold;">Soluzione</span><br>
<br>
Lo scheduler applica preemption e quindi puo' interrompere processi in
esecuzione.<br>
<br>
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 100%;">
  <tbody>
    <tr>
      <td style="vertical-align: top;">0-1<br>
      </td>
      <td style="vertical-align: top;">1-2<br>
      </td>
      <td style="vertical-align: top;">2-3<br>
      </td>
      <td style="vertical-align: top;">3-4<br>
      </td>
      <td style="vertical-align: top;">4-5<br>
      </td>
      <td style="vertical-align: top;">5-6<br>
      </td>
      <td style="vertical-align: top;">6-7<br>
      </td>
      <td style="vertical-align: top;">7-8<br>
      </td>
      <td style="vertical-align: top;">8-9<br>
      </td>
      <td style="vertical-align: top;">9-10<br>
      </td>
      <td style="vertical-align: top;">10-11<br>
      </td>
      <td style="vertical-align: top;">11-12<br>
      </td>
      <td style="vertical-align: top;">12-13<br>
      </td>
      <td style="vertical-align: top;">13-14<br>
      </td>
      <td style="vertical-align: top;">14-15<br>
      </td>
      <td style="vertical-align: top;">15-16<br>
      </td>
      <td style="vertical-align: top;">16-17<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">B</td>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">D<br>
      </td>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">A<br>
      </td>
    </tr>
  </tbody>
</table>
<br>
Nota: al tempo 5: b (Running) e D (Ready) hanno Remaining Time uguale a
1 --&gt; non si effettua lo switch <br>
<br>
Tempi di completamento&nbsp;&nbsp; &nbsp;&nbsp; <br>
A:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 17<br>
B: 6-1 =&nbsp;&nbsp; 5<br>
C: 11-3=&nbsp;&nbsp; 8<br>
D: 7-5 =&nbsp;&nbsp; 2<br>
<br>
Tempo di risposta<br>
<br>
A:&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 14.5<br>
B: 15.5-1=&nbsp; 4.5 <br>
C: 10.5-3=&nbsp; 9.5<br>
D: 7.5-5 =&nbsp; 6.5<br>
<br>
<br>
<span style="font-weight: bold;">E2.2</span><br>
Considerate ora la seguente politica di scheduling.<br>
Lo scheduler di lungo termine immette job nella coda di attesa
nell'ordine di arrivo<br>
(supponiamo che tale operazione abbia costo zero).<br>
<br>
<span style="font-weight: bold;">Per ogni job</span> <span
 style="font-weight: bold;">J</span> nel sistema lo scheduler di breve
termine mantiene <span style="font-weight: bold;">due contatori CPU_J
e WAIT_J</span> <br>
inizialmente a zero.<br>
Lo scheduler viene risvegliato dal clock <span
 style="font-weight: bold;">ogni 2
secondi</span> (2,4,6,..) ed inoltre <span style="font-weight: bold;">quando
un job
completa </span><br style="font-weight: bold;">
<span style="font-weight: bold;">la sua esecuzione</span>.<br>
<br>
In entrambi i casi esegue le seguenti operazioni: <br>
<ul>
  <li>per ogni job <span style="font-weight: bold;">J</span>
incrementa il suo contatore <span style="font-weight: bold;">CPU_J</span>
di <span style="font-weight: bold;">1</span> se <span
 style="font-weight: bold;">J</span> e' nello stato <span
 style="font-weight: bold;">running</span> in CPU, incrementa
il contatore <span style="font-weight: bold;">WAIT_J</span> di <span
 style="font-weight: bold;">1</span> se <span
 style="font-weight: bold;">J</span> e' nello stato <span
 style="font-weight: bold;">ready_to_run </span>(e' nella coda di
attesa)<br>
    <br>
  </li>
  <li>dopo aver aggiornato i contatori di ogni processo, seleziona per
l'esecuzione in CPU il processo tale&nbsp; che&nbsp; <span
 style="font-weight: bold;">WAIT_J - CPU_J </span>ha valore massimo su
tutti i <span style="font-weight: bold;">J</span>, applicando il
criterio<span style="font-weight: bold;"> First-Come-First-Served</span>
rispetto al <span style="font-weight: bold;">tempo di arrivo</span>
(vedi tabella) nel caso in cui siano possibili diverse scelte.<br>
  </li>
</ul>
Descrivere la sequenza di esecuzione dei job in
CPU&nbsp; e calcolare il <span style="font-weight: bold;">tempo di
completamento</span> e <br>
di <span style="font-weight: bold;">risposta</span> di ogni Job.<br>
<br>
<span style="font-weight: bold;"><br>
</span><br>
<span style="font-style: italic; font-weight: bold;">Soluzione</span><br>
<br>
<table cellpadding="2" cellspacing="2" border="0"
 style="text-align: left; width: 100%;">
  <tbody>
    <tr>
      <td style="vertical-align: top;">0-1<br>
      </td>
      <td style="vertical-align: top;">1-2<br>
      </td>
      <td style="vertical-align: top;">2-3<br>
      </td>
      <td style="vertical-align: top;">3-4<br>
      </td>
      <td style="vertical-align: top;">4-5<br>
      </td>
      <td style="vertical-align: top;">5-6<br>
      </td>
      <td style="vertical-align: top;">6-7<br>
      </td>
      <td style="vertical-align: top;">7-8<br>
      </td>
      <td style="vertical-align: top;">8-9<br>
      </td>
      <td style="vertical-align: top;">9-10<br>
      </td>
      <td style="vertical-align: top;">10-11<br>
      </td>
      <td style="vertical-align: top;">11-12<br>
      </td>
      <td style="vertical-align: top;">12-13<br>
      </td>
      <td style="vertical-align: top;">13-14<br>
      </td>
      <td style="vertical-align: top;">14-15<br>
      </td>
      <td style="vertical-align: top;">15-16<br>
      </td>
      <td style="vertical-align: top;">16-17<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">D&nbsp;<br>
      </td>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">A<br>
      </td>
      <td style="vertical-align: top;">A </td>
      <td style="vertical-align: top;">B<br>
      </td>
      <td style="vertical-align: top;">C<br>
      </td>
      <td style="vertical-align: top;">A<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wa=0 (*)<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wa=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wa=2</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wa=2</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wa=3</td>
      <td style="vertical-align: top;">Wa=4 </td>
      <td style="vertical-align: top;">Wa=5</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wa=5<br>
      </td>
      <td style="vertical-align: top;">Wa=6 </td>
      <td style="vertical-align: top;">Wa=7 </td>
      <td style="vertical-align: top;">/<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Ca=1<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Ca=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Ca=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Ca=2</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Ca=2</td>
      <td style="vertical-align: top;">Ca=2 </td>
      <td style="vertical-align: top;">Ca=2</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Ca=3<br>
      </td>
      <td style="vertical-align: top;">Ca=3 </td>
      <td style="vertical-align: top;">Ca=3 </td>
      <td style="vertical-align: top;">/<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wb=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wb=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wb=2</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wb=3</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wb=3</td>
      <td style="vertical-align: top;">Wb=4 </td>
      <td style="vertical-align: top;">Wb=5</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wb=6<br>
      </td>
      <td style="vertical-align: top;">/ </td>
      <td style="vertical-align: top;">/ </td>
      <td style="vertical-align: top;">/<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cb=0</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cb=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cb=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cb=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cb=2</td>
      <td style="vertical-align: top;">Cb=2 </td>
      <td style="vertical-align: top;">Cb=2</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cb=2<br>
      </td>
      <td style="vertical-align: top;">/ </td>
      <td style="vertical-align: top;">/ </td>
      <td style="vertical-align: top;">/<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wc=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wc=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wc=2</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wc=3</td>
      <td style="vertical-align: top;">Wc=4 </td>
      <td style="vertical-align: top;">Wc=4<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wc=5<br>
      </td>
      <td style="vertical-align: top;">Wc=6 </td>
      <td style="vertical-align: top;">/ </td>
      <td style="vertical-align: top;">/<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cc=0</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cc=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cc=1</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cc=1</td>
      <td style="vertical-align: top;"> Cc=1<br>
      </td>
      <td style="vertical-align: top;">Cc=2</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cc=2<br>
      </td>
      <td style="vertical-align: top;">Cc=2 </td>
      <td style="vertical-align: top;">/ </td>
      <td style="vertical-align: top;">/<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wd=1<br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wd=2</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Wd=3</td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/</td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/</td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/</td>
      <td style="vertical-align: top;">/<br>
      </td>
    </tr>
    <tr>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cd=0</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cd=0</td>
      <td style="vertical-align: top;"><br>
      </td>
      <td style="vertical-align: top;">Cd=0</td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/</td>
      <td style="vertical-align: top;">/</td>
      <td style="vertical-align: top;">/&nbsp;<br>
      </td>
      <td style="vertical-align: top;">/<br>
      </td>
      <td style="vertical-align: top;">/</td>
      <td style="vertical-align: top;">/<br>
      </td>
    </tr>
  </tbody>
</table>
<br>
Al tempo 0 i contatori sono tutti a 0, A entra e lo scheduler viene
attivato al tempo 2.<br>
(*) se nella colonna i-i+1 indica aggiornamento delle variabili al
tempo i+1 <br>
/ = completato<br>
<br>
Tempi di completamento&nbsp;&nbsp; &nbsp;&nbsp; <br>
A: 17<br>
B: 14 <br>
C: 13<br>
D: 6<br>
<br>
Tempo di risposta<br>
<br>
A: 12.5 <br>
B:&nbsp; 9,5<br>
C: 11,5<br>
D: 10,5<br>
<br>
</body>
</html>
